Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.
Bug 1951909 - Review Request: morphio - A python and C++ library for reading and writing neuronal morphologies
Summary: Review Request: morphio - A python and C++ library for reading and writing ne...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Robert-André Mauchin 🐧
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: fedora-neuro, NeuroFedora
TreeView+ depends on / blocked
 
Reported: 2021-04-21 07:43 UTC by Ankur Sinha (FranciscoD)
Modified: 2021-04-30 00:55 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-04-30 00:55:24 UTC
Type: ---
Embargoed:
zebob.m: fedora-review+


Attachments (Terms of Use)

Description Ankur Sinha (FranciscoD) 2021-04-21 07:43:02 UTC
Spec URL: https://ankursinha.fedorapeople.org/morphio/morphio.spec
SRPM URL: https://ankursinha.fedorapeople.org/morphio/morphio-3.0.2-1.fc34.src.rpm

Description:
MorphIO is a library for reading and writing neuron morphology files. It
supports the following formats:

- SWC
- ASC (aka. neurolucida)
- H5 v1
- H5 v2 is not supported anymore

It provides 3 C++ classes that are the starting point of every morphology
analysis:

- Soma: contains the information related to the soma.
- Section: a section is the succession of points between two bifurcations. To
  the bare minimum the Section object will contain the section type, the
  position and diameter of each point.
- Morphology: the morphology object contains general information about the
  loaded cell but also provides accessors to the different sections.

One important concept is that MorphIO is split into a read-only part and a
read/write one.


Fedora Account System Username: ankursinha

Comment 1 Robert-André Mauchin 🐧 2021-04-21 20:12:18 UTC
 - devel depends on main package so it is not necessary to reinclude the license here:

%files devel
%license COPYING COPYING.LESSER

 - Did you ask upstream to add a soname?

# Set a shared object version (0.0.0)
Patch4:         0005-Version-soname.patch

 - Remember that you have 	

ExcludeArch:    %{ix86} %{arm32}

in highfive so the package won't build on these arches too.


Package approved. Please consider the aforementioned points.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig not called in %post and %postun for Fedora 28 and later.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "GNU Lesser General Public License,
     Version 3", "*No copyright* GNU Lesser General Public License, Version
     3", "BSD 3-clause "New" or "Revised" License", "Boost Software License
     1.0". 188 files have unknown license. Detailed output of licensecheck
     in /home/bob/packaging/review/morphio/review-morphio/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[-]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 92160 bytes in 9 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-morphio
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: morphio-3.0.2-1.fc35.x86_64.rpm
          morphio-devel-3.0.2-1.fc35.x86_64.rpm
          python3-morphio-3.0.2-1.fc35.x86_64.rpm
          morphio-doc-3.0.2-1.fc35.noarch.rpm
          morphio-debuginfo-3.0.2-1.fc35.x86_64.rpm
          morphio-debugsource-3.0.2-1.fc35.x86_64.rpm
          morphio-3.0.2-1.fc35.src.rpm
morphio.x86_64: W: spelling-error Summary(en_US) morphologies -> morphological, morphology
morphio.x86_64: W: spelling-error %description -l en_US neurolucida -> neurological
morphio.x86_64: W: spelling-error %description -l en_US soma -> some, coma, soda
morphio.x86_64: W: spelling-error %description -l en_US accessors -> accessory, accessorizes, accessorize
morphio.src: W: spelling-error Summary(en_US) morphologies -> morphological, morphology
morphio.src: W: spelling-error %description -l en_US neurolucida -> neurological
morphio.src: W: spelling-error %description -l en_US soma -> some, coma, soda
morphio.src: W: spelling-error %description -l en_US accessors -> accessory, accessorizes, accessorize
7 packages and 0 specfiles checked; 0 errors, 8 warnings.

Comment 2 Ankur Sinha (FranciscoD) 2021-04-22 06:29:20 UTC
Thanks very much!

(In reply to Robert-André Mauchin 🐧 from comment #1)
>  - devel depends on main package so it is not necessary to reinclude the
> license here:
> 
> %files devel
> %license COPYING COPYING.LESSER

Corrected.

> 
>  - Did you ask upstream to add a soname?
> 
> # Set a shared object version (0.0.0)
> Patch4:         0005-Version-soname.patch

Not yet. I was waiting for the review, in case we needed to make any more tweaks. I'll start sending these patches upstream now. I'll update the soname version to whatever upstream decides (if they do, otherwise we stick to 0.0.0).

> 
>  - Remember that you have 	
> 
> ExcludeArch:    %{ix86} %{arm32}
> 
> in highfive so the package won't build on these arches too.
> 

Ah, yes! I'll add the ExludeArch to this package and note the bug too.

Thanks again. Updated spec/srpm:

Spec URL: https://ankursinha.fedorapeople.org/morphio/morphio.spec
SRPM URL: https://ankursinha.fedorapeople.org/morphio/morphio-3.0.2-1.fc34.src.rpm


Latest changes:

```
$ git diff HEAD^..HEAD
diff --git a/morphio.spec b/morphio.spec
index 8704561..4ec4a09 100644
--- a/morphio.spec
+++ b/morphio.spec
@@ -98,6 +98,11 @@ BuildRequires:  gsl-lite-devel
 BuildRequires:  hdf5-devel
 BuildRequires:  highfive-devel
 
+# highfive Does not build on 32 bit architectures, so this package cannot build
+# on them either
+# Issue filed upstream: https://github.com/BlueBrain/HighFive/issues/443
+# https://bugzilla.redhat.com/show_bug.cgi?id=1952348
+ExcludeArch:    %{ix86} %{arm32}
 
 %description %_description
 
@@ -237,7 +242,6 @@ PYTHONPATH=$PYTHONPATH:$RPM_BUILD_ROOT/%{python3_sitelib}:$RPM_BUILD_ROOT/%{pyth
 %{_libdir}/libmorphio.so.0.0.0
 
 %files devel
-%license COPYING COPYING.LESSER
 %doc CHANGLOG.md CONTRIBUTING.md README.rst
 %{_includedir}/%{name}
 %{_libdir}/libmorphio.so
@@ -256,6 +260,10 @@ PYTHONPATH=$PYTHONPATH:$RPM_BUILD_ROOT/%{python3_sitelib}:$RPM_BUILD_ROOT/%{pyth
 %endif
 
 %changelog
+* Thu Apr 22 2021 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 3.0.2-1
+- Add excludearch because of highfive
+- do not carry licenses in devel package, since it depends on the main package already
+
 * Wed Apr 21 2021 Ankur Sinha <ankursinha AT fedoraproject DOT org> - 3.0.2-1
 - Enable tests
```


Requesting SCM now.

Cheers,
Ankur

Comment 3 Tomas Hrcka 2021-04-22 10:54:57 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/morphio

Comment 4 Fedora Update System 2021-04-22 12:37:59 UTC
FEDORA-2021-3701127a6c has been submitted as an update to Fedora 34. https://bodhi.fedoraproject.org/updates/FEDORA-2021-3701127a6c

Comment 5 Fedora Update System 2021-04-22 18:25:31 UTC
FEDORA-2021-3701127a6c has been pushed to the Fedora 34 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2021-3701127a6c \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2021-3701127a6c

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 6 Fedora Update System 2021-04-30 00:55:24 UTC
FEDORA-2021-3701127a6c has been pushed to the Fedora 34 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.